/***************************************
 * soubor slova.c
 * nacita slova ze vstupniho textu
 * vytvori jejich seznam s cetnosti vyskytu
 * na zaver seznam vytiskne
 ***************************************/

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#define	DELKA_RADKU	80
#define PAGE		24

/* typedef struct info; */
typedef struct struct_info {
		int pocet;
		char *slovo;
		struct struct_info *dalsi;
	       } info;

void pridej_slovo(info **prvni, char *s)
{
 info *prvek;
 prvek = *prvni;
 while (prvek != NULL)
   {
   /* dokud neni na konci, porovnava nove
    * s ulozenym */
    if (strcmp(s, prvek->slovo) == 0)
      {
       (prvek->pocet)++;
       /* shoda nalezena, pocet se zvetsil */
       return;
      }
    prvek = prvek->dalsi;
    /* prejdi na naslednika */
   }
 /* shoda nenalezena, je nutno vytvorit novy prvek */
 prvek = malloc(sizeof(info));
 /* a vyalokovat i misto pro kopii slova */
 prvek->slovo = malloc(strlen(s) + 1);
 strcpy(prvek->slovo, s);
 /* nastavi pocet vyskytu na jedna
  * a pridat prvek na zacatek seznamu */
 prvek->pocet = 1;
 prvek->dalsi = *prvni;
 *prvni = prvek;
} /* void pridej_slovo(info **prvni, char *s) */

void tiskni(info *prvni)
{
 int vytisknuto = 0;
 while (prvni != NULL)
 /* dokud neni na konci seznamu */
   {
    printf("%4d..%s\n", prvni->pocet, prvni->slovo);
    prvni = prvni->dalsi;
    vytisknuto++;
    /* tiskne stukturu prvek a pocita, kolikrat
     * kontroluje totoz vystup na obrazovku
     * kvuli pozastaveni vypisu */
    if ((vytisknuto % PAGE) == 0)
      {
       printf("pro pokracovani stiskni enter");
       getchar();
       /* prave timto ceka na enter */
       printf("\n");
      }
   }
} /* void tiskni(info *prvni) */

int main(int argc, char **argv)
{
 info *prvni = NULL;
 char radek[DELKA_RADKU + 1], *slovo;
 char oddelovace[] = " \\t\\n\\r";
 /* retezec obsahuje mezeru TAB NL a CR */
 FILE *f;

 if (argc != 1)
   f = fopen(argv[1], "rt");
   /* otevreni textoveho streamu */
 else
   f = stdin;
   /* pouzije standardni vstup */
 if (f == NULL)
   return(1);
   /* zadny ze vstupu neuspel */
 while (fgets(radek, DELKA_RADKU, f) != NULL)
   {
    /* dokud neni konec vstupu
     * cte radek za radkem
     * a vybira z nej slova */
    slovo = strtok(radek, oddelovace);
    /* nastaveni funkce a navrat
     * prvniho slova z radku */
    while (slovo != NULL)
      {
       pridej_slovo(&prvni, slovo);
       /* slovo do seznamu */
       slovo = strtok(NULL, oddelovace);
       /* ziskani dalsiho slova z radku */
      }
   }
 tiskni(prvni);
 return 0;
}

